#ifndef PV_PVCALLROUTINES_H
#define PV_PVCALLROUTINES_H TRUE
/*
**  $Filename: PVCallRoutines.h $
**  $Release: 1.33 $
**  $Revision: 37.1428 $
**  $Date: 11 Sep 92 $
**
**  List with PVCallTable protos (see 'TheWizardCorner')
**
**   1992 Jorrit Tyberghein, included with PowerVisor
**	    All Rights Reserved
*/

#ifndef PV_PVMEMORY_H
#include "PVMemory.h"
#endif

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif


void PVCCreateFunction (char *);
void PVCError (char *);
void PVCAdvanceHistory ();
void PVCLowerHistory ();
void PVCGetHistoryLine ();
void PVCRefreshStringG ();
void PVCInstallPreCmd (char *);
int PVCEvaluate (char *);
void PVCRemVar (char *);
char *PVCParseString (char *);
void PVCCopyString (char *);
void PVCAddStringToHist (char *);
char *PVCGetStringGBuf ();
void PVCAppendString (char *);
char *PVCSkipSpaces (char *);
void PVCSetCursorPos (char *);
void PVCInstallPostCmd (char *);
void PVCSetDebugMode (char *);
int PVCGetExecLevel ();
struct StringInfo *PVCGetStringInfo ();
char *PVCGetSnapBuffer ();
void PVCInstallSnapCmd (char *);
void PVCBeep (char *);
int PVCGetVarAddress (char *);
void PVCCreateConstant (char *);
int PVCCompareStrings (char *);
int PVCCallMLScript (char *);
struct EvalBase *PVCGetEvalBase ();
struct ARexxBase *PVCGetARexxBase ();
struct DebugBase *PVCGetDebugBase ();
struct FileBase *PVCGetFileBase ();
struct GeneralBase *PVCGetGeneralBase ();
struct ListBase *PVCGetListBase ();
struct MainBase *PVCGetMainBase ();
APTR PVCGetRoutines ();
APTR PVCGetModeRoutines ();
APTR PVCGetRexxList ();
struct ScreenBase *PVCGetScreenBase ();
struct MemoryBase *PVCGetMemoryBase ();
struct Gadget *PVCGetStringGadget ();
int PVCErrorHandler (APTR);
void PVCInstallQuitCmd (char *);
PVBLOCK PVCConvertAlias (char *);
int PVCAddAutoClear (PVBLOCK);
PVBLOCK PVCAllocPVBlock (ULONG);
void PVCFreePVBlock (APTR);
void PVCComputeGadgetSignal ();
void PVCPrint (char *,ULONG);
void PVCPrintNum (ULONG);
int PVCAddGlobalAutoClear (PVBLOCK);
void PVCRemoveGlobalAutoClear (PVBLOCK);
void PVCClosePVHandle (BPTR);
APTR PVCReAllocPVMemoryBlock (struct PVMemoryBlock *,ULONG);
void PVCRefreshLogWin (struct LogicalWindow *);
int PVCSnapWord (struct LogicalWindow *, ULONG, ULONG, char *, ULONG);
int PVCDisassemble (char *, ULONG, APTR);
int PVCCmdDisassemble (char *);
APTR PVCAllocMem (ULONG size, ULONG attr);
void PVCFreeMem (APTR ptr, ULONG size);
void PVCReAlloc (APTR ptr, ULONG oldsize, ULONG newsize, ULONG attr);


#endif
